<p>Jedna od osnovnih vještina koje moramo savladati kada je riječ o računalnoj grafici, jest provođenje različitih transformacija nad točkama u prostoru, bilo da govorimo o 2D prostoru, bilo da govorimo o 3D prostoru. Transformacije će nam omogućiti da objekte pomičemo po sceni, rotiramo ih, mijenjamo im veličinu te ih deformiramo. No transformacije će nam omogućiti i da, jednom kad je scena posložena, mijenjamo položaj iz kojeg je promatramo, mijenjamo smjer u kojem gledamo i još mnoge druge stvari. U okviru ove minilekcije, pogledat ćemo najprije kako se transformacije provode u 2D prostoru.</p>

<p>U 2D prostoru, svaka točka zapisiva je kao uređeni par \((x,y)\). Točku pri tome možemo promatrati i kao radij-vektor koji kreće iz ishodišta i vrh mu je upravo u točki \((x,y)\); ovakvo razmišljanje pomoći će nam kada ćemo, primjerice, razmatrati kako se provodi transformacija rotacije: ona će zadani radij-vektor rotirati oko ishodišta za zadani kut pri čemu ćemo razmatrati matematički koordinatni sustav (+x osi u desno, +y os prema gore) i pozitivan smjer rotacije (od +x osi prema +y osi).</p>

<p>Općenito, razmatrat ćemo porodicu Afinih transformacijama; radi se o transformacijama koje nisu projekcije pa koje čuvaju dimenzionalnost prostora. Te će transformacije točku \((x,y)\) preslikati u novu točku \((\hat x,\hat y)\), pri čemu ćemo svaku od komponenata nove točke izračunati prema općenitim izrazima:
\[
\begin{align*}
\hat x &amp;= a \cdot x + c \cdot y + e\\
\hat y &amp;= b \cdot x + d \cdot y + f
\end{align*}
\]
gdje su \(a,b,c,d,e,f \in \mathbb{R}\).</p>

<p>Pri radu s transformacijama, željet ćemo pri tome svaku transformaciju modelirati jednim objektom koji ćemo koristiti u programima kako ne bismo morali raditi sa šest nezavisnih brojeva. U tom smislu, točke možemo doista modelirati vektorima koje ćemo tretirati kao jednoretčane matrice. Učinimo li to, prethodna dva izraza koja opisuju opći oblik transformacije moći ćemo zapisati u matričnom obliku kako slijedi:
\[
[\begin{array}{cc}\hat x &amp; \hat y\end{array}] = 
[\begin{array}{cc}x &amp; y\end{array}] \cdot
\left[ \begin{array}{cc}a &amp; b \\ c &amp; d\end{array} \right]
+ [\begin{array}{cc}e &amp; f\end{array}] = \vec x \cdot \mathbf{A} + \vec b
\]
Ovakav zapis omogućit će nam da umjesto 6 nezavisnih brojeva pratimo jednu matricu te jedan vektor (\(\mathbf{A}, \vec b\)). No možemo i bolje od toga. Točke iz \(k\)-dimenzijskog radnog prostora predstavit ćemo u (\(k+1\))-dimenzijskom homogenom prostoru gdje je primjerice dvodimenzijska točka (\(x,y\)) predstavljena kao trodimenzijska točka (\(\lambda \cdot x,\lambda \cdot y, \lambda\)) uz \(\lambda \neq 0\). Pri tome je najjednostavnije odabrati \(\lambda=1\) pa pisati (\(x,y,1\)). Uz ovaj dogovor, cjelokupna se transformacija sada može zapisati uporabom samo jedne matrice dimenzija \(3 \times 3\):
\[
[\begin{array}{ccc}\hat x &amp; \hat y &amp; 1\end{array}] = 
[\begin{array}{ccc}x &amp; y &amp; 1\end{array}] \cdot
\left[ \begin{array}{ccc}a &amp; b &amp; 0\\ c &amp; d &amp; 0\\ e &amp; f &amp; 1\end{array} \right] = [\begin{array}{cc}\vec x &amp; 1\end{array}] \cdot \left[ \begin{array}{cc} \mathbf{A} &amp; \vec 0^T \\ \vec b &amp; 1\end{array}\right] = [\begin{array}{cc}\vec x &amp; 1\end{array}] \cdot \mathbf{M}.
\]
Uočimo da napisana matrica ima 6 stupnjeva slobode: posljednji stupac mora biti (0,0,1).
</p>
<p>U prethodnom izrazu koristili smo nekoliko novih oznaka: vektor \(\vec x\) označava promatranu točku u radnom prostoru čije su komponente (x,y); vektor \(\vec b\) predstavlja vektor pomaka čije su komponente (e,f); matrica \(\mathbf{A}\) je matrica \(2 \times 2\) čije su komponente po retcima redom a, b, c, d i za ovu matricu pokazat ćemo u nastavku da modelira linearnu transformaciju; matrica \(\mathbf{M}\) je matrica afine transformacije i u ovom slučaju je dimenzija \(3 \times 3\); simbolički je možemo zapisati kao matricu čiji su elementi u prvom retku matrica \(\mathbf{A}\) te nul-vektor a u drugom retku vektor \(\vec b\) te skalar 1.</p>  

<p>U nastavku, razmotrit ćemo četiri uobičajene transformacije:</p>
<ol>
<li>translaciju,</li>
<li>skaliranje,</li>
<li>rotaciju i</li>
<li>smik.</li>
</ol>

<p>No prije toga, idemo se ukratko upoznati/podsjetiti koja svojstva imaju Afine transformacije, nakon čega ćemo pogledati kako možemo doći do matrice koja opisuje linearnu transformaciju.</p>

